#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n;
	if (has_opt("minn")) {
		int minn = opt<int>("minn");
		int maxn = opt<int>("maxn");
		n = rnd.next(minn, maxn);
	} else {
		n = opt<int>("n");
	}


	double p1 = (has_opt("p1") ? opt<double>("p1") : 1.0 / 3);
	double p2 = (has_opt("p2") ? opt<double>("p2") : 1.0 / 3);

	cout << n << "\n";
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			double x = rnd.next();
			char c;
			if (x < p1) {
				c = '.';
			} else {
				if (x < p1 + p2) {
					c = '#';
				} else {
					c = '?';
				}
			}
			cout << c;
		}
		cout << '\n';
	}

	return 0;
}